program NHNMO
  use sep
  use nonhyp_mod

  implicit none

  integer 				:: n1,n2,n3,niter,n2out,stat,iter,test
  integer				:: iadj, i1, i2, i3, isos, iver, ilint
  logical				:: adj, add, sos, ver, lint, vel, slo
  real 					:: d1,d2,d3,o1,o2,o3,v,g,off
  real, dimension(:,:,:), allocatable	:: model, data
  real, dimension(:,:), allocatable	:: slow, gamma, velo
  

  call sep_init()

  call from_history ("n1", n1)
  call from_history ("d1", d1)
  call from_history ("o1", o1)

  call from_history ("n2", n2)
  call from_history ("d2", d2)
  call from_history ("o2", o2)

  call from_history ("n3", n3)
  call from_history ("d3", d3)
  call from_history ("o3", o3)

  call from_param("v",v,1000.)
  call from_param("g",g,1.)
  call from_param( "adj",  iadj, 0);   adj  = (iadj==1)
  call from_param( "sos", isos, 1); sos = (isos==0)
  call from_param( "verb", iver, 0); ver = (iver==0)
  call from_param( "lint", ilint, 0); lint = (ilint==0)

  call to_history ("o1", o1)
  call to_history ("d1", d1)
  call to_history ("n1", n1)

  call to_history ("o2", o2)
  call to_history ("d2", d2)
  call to_history ("n2", n2)

  call to_history ("o3", o3)
  call to_history ("d3", d3)
  call to_history ("n3", n3)


  vel = exist_file ("velocity")
  slo = exist_file ("slow")

  call sep_close ()

write(0,*) "finished history"
   
  if (allocated (data) ) deallocate (data)
  if (allocated (model) ) deallocate (model)
  if (allocated (slow) ) deallocate (slow)
  if (allocated (gamma) ) deallocate (gamma)
   

  allocate (data(n1,n2,n3), STAT=test)
	if(test /=0) call seperr("cant allocate data")
  allocate (model(n1,n2,n3),   STAT=test)
	if(test /=0) call seperr("cant allocate model")
  allocate (slow(n1,n3),  STAT=test)
	if(test /=0) call seperr("cant allocate slow")
  allocate (gamma(n1,n3),  STAT=test)
	if(test /=0) call seperr("cant allocate gamma")

if (ver) then

 write(0,*) "data size", n1*n2*4
 write(0,*) "space storage", (n1*n2*4)*2
 write(0,*) "done storage"

end if

if (vel) then
  allocate (velo(n1,n3), STAT=test)
	if(test /=0) call seperr("cant allocate velo")
  call sep_read(velo,"velocity")
  slow=1/velo
end if

if (slo) call sep_read(slow,"slow")
 if (ver) write(0,*) "Im here"
call sep_read(gamma,"gamma")
 if (ver) write(0,*) "read gamma"

if (ver) then
	write(0,*) "veryfing slow and gamma values"
	write(0,*) "min-slow", minval(slow)
	write(0,*) "max-slow", maxval(slow)
	write(0,*) "min-gamma", minval(gamma)
	write(0,*) "max-gamma", maxval(gamma)
end if

  if (adj) then
    call sep_read (data)
    model = 0.
	if (ver) write(0,*) "Doing Adjoint"
  else
    call sep_read (model)
    data = 0.
	if (ver) write(0,*) "Doing Operator"
  end if

!    call sep_read (slow)
!    call sep_read (gamma)

do i3=1,n3

 do i2= 1,n2

  off = o2 + (i2-1)*d2
  call nonhyp_init( o1, d1, slow(:,i3), gamma(:,i3), off, n1, lint)
  if (adj) then
  stat = nonhyp_lop (adj,add,model(:,i2,i3),data(:,i2,i3)) 	! modeling
  else
  stat = nonhyp_lop (adj,add,model(:,i2,i3),data(:,i2,i3)) 	! modeling
  end if

 end do

 if (ver) then
   write(0,*) "done cmp", i3
 end if

end do

!!   call sep_write (data)
  if (adj) then
   call sep_write (model)
  else
   call sep_write (data)
  end if
write(0,*) "done writting" 

   call nonhyp_clear

  write(0,*) "done"

  deallocate( model, STAT=test)
  if (test /=0) call seperr("cant deallocate model")
  deallocate( data, STAT=test)
  if (test /=0) call seperr("cant deallocate dat")
  deallocate( slow, STAT=test)
  if (test /=0) call seperr("cant deallocate slow")
  deallocate( gamma, STAT=test)
  if (test /=0) call seperr("cant deallocate gamma")
  if (vel) then
   deallocate (velo, STAT=test)
   if(test /=0) call seperr("cant deallocate velo")
  end if

  call exit(0)
end program NHNMO
