program NHTMO
  use sep
  use newtri

  implicit none

  integer 	:: n1,n2,n3,niter,n2out,stat,iter,test
  integer	:: iadj, i1, i2, i3, isos, iver
  logical	:: adj, add, vel, ver, slo
  real 		:: d1,d2,d3,o1,o2,o3,v,g,off,anti,eps

  real, dimension(:,:,:), allocatable  :: model, data
  real, dimension(:,:), allocatable    :: slow, gamma, velocity
  

  call sep_init()

  call from_history ("n1", n1)
  call from_history ("d1", d1)
  call from_history ("o1", o1)

  call from_history ("n2", n2)
  call from_history ("d2", d2)
  call from_history ("o2", o2)

  call from_history ("n3", n3)
  call from_history ("d3", d3)
  call from_history ("o3", o3)

  call from_param("v",v,1000.)
  call from_param("g",g,1.)
  call from_param("anti",anti,0.)
  call from_param("eps",eps,d1)
  call from_param( "adj",  iadj, 0);  adj  = (iadj==1)
  call from_param( "verb", iver, 0);  ver  = (iver==0)

  call to_history ("o1", o1)
  call to_history ("d1", d1)
  call to_history ("n1", n1)

  call to_history ("o2", o2)
  call to_history ("d2", d2)
  call to_history ("n2", n2)

  call to_history ("o3", o3)
  call to_history ("d3", d3)
  call to_history ("n3", n3)

  call to_history("anti",  anti)
  call to_history( "adj",  iadj)
  call to_history( "verb", iver)

  vel = exist_file ("velocity")
  slo = exist_file ("slow")

  call sep_close ()

write(0,*) "finished history"
   
  if (allocated (data) ) deallocate (data)
  if (allocated (model) ) deallocate (model)
  if (allocated (slow) ) deallocate (slow)
  if (allocated (gamma) ) deallocate (gamma)
   

  allocate (data(n1,n2,n3), STAT=test)
	if(test /=0) call seperr("cant allocate data")
  allocate (model(n1,n2,n3),   STAT=test)
	if(test /=0) call seperr("cant allocate model")
  allocate (gamma(n1,n2),  STAT=test)
	if(test /=0) call seperr("cant allocate gamma")
  allocate (slow(n1,n2),  STAT=test)
	if(test /=0) call seperr("cant allocate slow")

if (ver) then

 write(0,*) "data size", n1*n2*n3*4, "bytes"
 write(0,*) "space storage", (n1*n2*n3*4)*2
 write(0,*) "done storage"

end if

    call sep_read (data)
    model=0.

    if (vel) then
      allocate (velocity(n1,n2),  STAT=test)
      if(test /=0) call seperr("cant allocate velocity")
      call sep_read (velocity,"velocity")
      slow = 1/velocity
    end if

    if (slo) call sep_read (slow,"slow")
    call sep_read (gamma,"gamma")

if (ver) then
	write(0,*) "veryfing slow and gamma values"
	write(0,*) "min-slow:", minval(slow)
	write(0,*) "max-slow:", maxval(slow)
	write(0,*) "min-gamma:", minval(gamma)
	write(0,*) "max-gamma:", maxval(gamma)
end if

do i3= 1,n3
 do i2= 1,n2

  off = o2 + (i2-1)*d2
  call newtri_init( o1, d1, n1, off, d2, slow(:,i2), gamma(:,i2), 0., 1., anti, eps)
  if (adj) then
  stat = newtri_lop (adj,.true.,model(:,i2,i3),data(:,i2,i3)) ! modeling
  else
  stat = newtri_lop (adj,.true.,data(:,i2,i3),model(:,i2,i3)) ! modeling
  end if

 end do
end do

   call sep_write (model)

write(0,*) "done writting" 

   call nonhyp_clear

  deallocate( model, STAT=test)
  if (test /=0) call seperr("cant deallocate model")
  deallocate( data, STAT=test)
  if (test /=0) call seperr("cant deallocate dat")
  if (vel) deallocate( velocity )
  deallocate (slow, gamma)


  call exit(0)
end program NHTMO
