program ONHNMO
  use sep
  use ononhyp_mod

  implicit none

  integer 				:: n1,n2,n3,niter,nt,n2out,stat,iter,test
  integer				:: iadj, i1, i2, i3, isos, iver, ilint
  logical				:: adj, add, sos, ver, lint, vel, slo
  real 					:: d1,d2,d3,o1,o2,o3,v,g,off,ot,dt
  real, dimension(:,:,:), allocatable	:: model, data
  real, dimension(:,:), allocatable	:: velp, vels
  

  call sep_init()

  call from_history ("n1", n1)
  call from_history ("d1", d1)
  call from_history ("o1", o1)

  call from_history ("n2", n2)
  call from_history ("d2", d2)
  call from_history ("o2", o2)

  call from_history ("n3", n3)
  call from_history ("d3", d3)
  call from_history ("o3", o3)

  call from_param("nt",nt,1000)
  call from_param("dt",dt,0.004)
  call from_param("ot",ot,0.0)
  call from_param( "adj",  iadj, 0);   adj  = (iadj==1)
  call from_param( "sos", isos, 1); sos = (isos==0)
  call from_param( "verb", iver, 0); ver = (iver==0)
  call from_param( "lint", ilint, 0); lint = (ilint==0)

  call to_history ("o1", ot)
  call to_history ("d1", dt)
  call to_history ("n1", nt)

  call to_history ("o2", o2)
  call to_history ("d2", d2)
  call to_history ("n2", n2)

  call to_history ("o3", o3)
  call to_history ("d3", d3)
  call to_history ("n3", n3)


  call sep_close ()

write(0,*) "finished history"
  allocate (data(n1,n2,n3), STAT=test)
	if(test /=0) call seperr("cant allocate data")
  allocate (model(nt,n2,n3),   STAT=test)
	if(test /=0) call seperr("cant allocate model")
  allocate (velp(n1,n3),  STAT=test)
	if(test /=0) call seperr("cant allocate slow")
  allocate (vels(n1,n3),  STAT=test)
	if(test /=0) call seperr("cant allocate gamma")

if (ver) then

 write(0,*) "data size", n1*n2*4
 write(0,*) "space storage", (n1*n2*4)*2
 write(0,*) "done storage"

end if

call sep_read(velp,"Pvel")
 if (ver) write(0,*) "read Pvel"
call sep_read(vels,"Svel")
 if (ver) write(0,*) "read Svel"

if (ver) then
	write(0,*) "veryfing velp and vels values"
	write(0,*) "min-velp", minval(velp)
	write(0,*) "max-velp", maxval(velp)
	write(0,*) "min-vels", minval(vels)
	write(0,*) "max-vels", maxval(vels)
end if

  if (adj) then
    call sep_read (data)
    model = 0.
	if (ver) write(0,*) "Doing Adjoint"
  else
    call sep_read (model)
    data = 0.
	if (ver) write(0,*) "Doing Operator"
  end if

do i3=1,n3

 do i2= 1,n2

  off = o2 + (i2-1)*d2
  call ononhyp_init( ot, dt, nt, o1, d1, n1, off, lint)
  if (adj) then
  stat = ononhyp_lop (adj,add,model(:,i2,i3),data(:,i2,i3),velp(:,i3),vels(:,i3)) ! modeling
  else
  stat = ononhyp_lop (adj,add,model(:,i2,i3),data(:,i2,i3),velp(:,i3),vels(:,i3)) ! modeling
  end if

 end do

 if (ver) write(0,*) "done cmp", i3

end do

  if (adj) then
   call sep_write (model)
  else
   call sep_write (data)
  end if
write(0,*) "done writting" 

  write(0,*) "done"

  deallocate( model, STAT=test)
  if (test /=0) call seperr("cant deallocate model")
  deallocate( data, STAT=test)
  if (test /=0) call seperr("cant deallocate data")
  deallocate( velp, STAT=test)
  if (test /=0) call seperr("cant deallocate velp")
  deallocate( vels, STAT=test)
  if (test /=0) call seperr("cant deallocate vels")

  call exit(0)
end program ONHNMO
