module nonhyp_mod
! Normal moveout
  use sep
  implicit none
  integer, private :: nt, i
  integer, private :: test 
  logical, private :: lint
  real, private :: t0, off 
  real, private :: dt 
  real, private :: xs, cc, xs2
  real, save, pointer, private :: sl(:), g(:)
  contains

  subroutine nonhyp_init ( t0_in,dt_in,slo,ga,off_in,nt_in,lint_in)

    real    :: t0_in 
    real    :: dt_in 
    real, target    :: slo(:), ga(:)
    integer    :: nt_in 
    real    :: off_in
    logical :: lint_in

    sl => slo
     g => ga

    t0 = t0_in; dt = dt_in; nt = nt_in
    lint = lint_in; off = off_in


  end subroutine


  function nonhyp_lop ( adj,add, tt, zz) result(stat)

    integer            :: stat 
    logical,intent(in) :: adj,add
    real, dimension(:), intent(inout)  :: tt, zz
    call nonhyp_lop2(adj,add,tt,zz )
    stat=0

  end function 


  subroutine nonhyp_lop2( adj,add,tt,zz )

    logical,intent(in) :: adj,add 
    real, dimension(:), intent(inout)  :: tt, zz
    integer   it, iz
    real t, z2, t2, z, xs, xs2
    real f, fx, gx, wt,g2, sg, cc, eps

    eps=0.1
    do iz= 2, nt  
      xs  = off*sl(iz); xs2 = xs*xs
      g2  = g(iz)*g(iz); sg = sqrt(g(iz))
      cc  = ( 2 - (g2 + 1/g2) )/( 4 * ((sg + 1/sg)**4) )
      z   = t0 + dt*(iz-1)
      z2  = z*z
      t2  =  z2 + xs2 + ((cc*xs2*xs2*z2)/(z2*z2+eps*eps))
      t   = sqrt(t2)

      f=0. ; fx=0. ; gx=0. 
      it=0
      if (lint) then
	f=(t-t0)/dt; i=f; it=1+i; fx=f-i; gx=1.-fx
	if (it > nt-1 .or. it<0 ) exit
      else
        it  = 1.5 + (t - t0)/dt
        if ( it > nt .or. it<0 ) exit
      end if

      wt = 1.

      if ( adj) then
	if (lint) then
          tt(it)   =    tt(it)   + zz(iz)*wt*gx
	  tt(it+1) =    tt(it+1) + zz(iz)*wt*fx
	else
	  tt(it)   =    tt(it)   + zz(iz)
	end if
      else
	if (lint) then
          zz(iz)   =     zz(iz) + tt(it)*wt*gx
	  zz(iz+1) =     zz(iz+1) + tt(it)*wt*fx
	else
	  zz(iz)   =     zz(iz) + tt(it)
	end if
      end if
    end do 

  end subroutine


  subroutine nonhyp_clear()

  end subroutine 


end module 
