module ononhyp_mod
! Normal moveout
  use sep
  implicit none
  integer, private :: nt, i, nz
  integer, private :: test 
  logical, private :: lint
  real, private :: t0, off, z0
  real, private :: dt, dz
  real, private :: xs, cc, xs2
  contains

  subroutine ononhyp_init (t0_in,dt_in,nt_in,z0_in,dz_in,nz_in,off_in,lint_in)

    real    :: t0_in, z0_in 
    real    :: dt_in, dz_in
    integer    :: nt_in, nz_in
    real    :: off_in
    logical :: lint_in

    t0 = t0_in; dt = dt_in; nt = nt_in; dz = dz_in
    lint = lint_in; off = off_in; z0 = z0_in; nz = nz_in


  end subroutine


  function ononhyp_lop (adj,add,tt,zz,alpha,beta) result(stat)

    integer            :: stat 
    logical,intent(in) :: adj,add
    real, dimension(:), intent(inout)  :: tt, zz
    real, dimension(:), intent(inout)  :: alpha, beta
    call ononhyp_lop2(adj,add,tt,zz,alpha,beta)
    stat=0

  end function 


  subroutine ononhyp_lop2(adj,add,tt,zz,alpha,beta)

    logical,intent(in) :: adj,add 
    real, dimension(:), intent(inout)  :: tt, zz
    real, dimension(:), intent(in   )  :: alpha, beta
    integer   it, iz
    real t, z2, t2, z, xs, xs2, off2, a1, a2, a3
    real f, fx, gx, wt,g2, sg, cc, c1, c2, c3

    a1=0; a2=0; a3=0
    do iz= 1, nz  
      off2 = off*off
      z   = z0 + dz*(iz-1)
      a1  = a1 + (z*((1/alpha(iz)) + (1/beta(iz))))
      a2  = a2 + (z*(alpha(iz)+beta(iz)))
      a3  = a3 + (z*(alpha(iz)**3 + beta(iz)**3))
      c1  = a1**2
      c2  = a1/a2
      c3  = (a2**2 - a1*a3)/(4*(a2**4))
      t2  = c1 !+ c2*off2 ! + c3*off2*off2
      t   = sqrt(t2)

      if (lint) then
	f=(t-t0)/dt; i=f; it=1+i; fx=f-i; gx=1.-fx
	if (it>nt-1) exit
      else
        it=1.5+(t-t0)/dt
        if (it>nt) exit
      end if

      wt = 1.

      if (adj) then
	if (lint) then
          tt(it)   =    tt(it)   + zz(iz)*wt*gx
	  tt(it+1) =    tt(it+1) + zz(iz)*wt*fx
	else
	  tt(it)   =    tt(it)   + zz(iz)
	end if
      else
	if (lint) then
          zz(iz)   =     zz(iz) + tt(it)*wt*gx
	  zz(iz+1) =     zz(iz+1) + tt(it)*wt*fx
	else
	  zz(iz)   =     zz(iz) + tt(it)
	end if
      end if
    end do

  end subroutine

end module 
